#!/usr/bin/env python3
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: vorname.py 679 2014-06-24 13:57:18Z pieper $


#
# Quellcode als Musterlösung für das Arbeitsblatt 
# ab_02_daten_ordnen.tex
# mit Hilfe der ZA-Klasse List in Python
#
from list import List

class Sortier:
  def __init__(self):
    self.unsortiert= List()
    self.sortiert  = List()
 
  def fuegeAn(self,element):
    self.unsortiert.append(element)   

  def korrektEinfuegen(self, elem, lis):    
    if not lis.hasAccess():
      lis.append(elem)  
      return 
    if (str(elem) < str(lis.getObject())):
      lis.insert(elem)
    else:  
      lis.next()
      self.korrektEinfuegen(elem, lis)

  def sortiere(self):                 
    self.unsortiert.toFirst()
    if self.unsortiert.isEmpty():
      return
    self.sortiert.toFirst()
    if self.sortiert.isEmpty():
      self.sortiert.append(self.unsortiert.getObject())
      self.sortiert.toFirst()
    else:
      self.korrektEinfuegen(self.unsortiert.getObject(), self.sortiert)
      self.sortiert.toFirst()
    self.unsortiert.remove()
    self.sortiere()
   

if __name__ == "__main__":
  vornamenSortierer= Sortier()

  vornamenSortierer.fuegeAn("Zeda")
  vornamenSortierer.fuegeAn("Elif")
  vornamenSortierer.fuegeAn("Anne")
  vornamenSortierer.fuegeAn("Renate")
  vornamenSortierer.fuegeAn("Karl") 
  vornamenSortierer.fuegeAn("Britta")
  vornamenSortierer.fuegeAn("Berta")

  print(vornamenSortierer.unsortiert)
  vornamenSortierer.sortiere()
  print(vornamenSortierer.sortiert)
  
  
